// Author : Seb Lee-Delisle
// Blog : www.sebleedelisle.com
// Company : www.pluginmedia.net
// Mail : sebleedelisle@gmail.com
//
// This work is licensed under a Creative Commons 2.0  non-commercial share-alike License.

// Full details at 
// http://creativecommons.org/licenses/by-nc-sa/2.0/uk/

package net.pluginmedia.pv3d
{
	import org.papervision3d.core.geom.renderables.Particle;
	import org.papervision3d.core.math.Number3D;
	import org.papervision3d.materials.special.ParticleMaterial;

	public class SnowFlake extends Particle
	{
		
		public var vel 		 : Number3D; 
		public var rotationZ : Number = 0; 
		public var spin 	 : Number; 
		
		public function SnowFlake(material:ParticleMaterial, size:Number=1, x:Number=0, y:Number=0, z:Number=0)
		{
			super(material, size, x, y, z);
		
			vel = new Number3D((Math.random()*2)-1, -3, (Math.random()*2)-1); 
			
		}
		
		public function update(cubesize : Number) : void
		{
			x += vel.x; 
			y += vel.y; 
			z += vel.z; 
			
			var halfsize : Number = cubesize>>1; 
			
			if(y<-halfsize) y=halfsize; 
			if(x<-halfsize) x=halfsize; 
			else if(x>halfsize) x= -halfsize; 
			if(z<-halfsize) z=halfsize; 
			else if(z>halfsize) z=-halfsize; 
			
			
			
		}
		
	}
}